'use strict';

var ClienteController = angular.module('ClienteController', ['ngCookies']);

ClienteController.controller('ClienteCtrl', ['$scope', '$window', '$location', 'Cliente', 'CacheApp',
    ($scope, $window, $location, Cliente, CacheApp) => {

        $scope.ValidaCliente = () => {
            if ($scope.formLogin.txtEmail.$error.required || $scope.formLogin.txtSenha.$error.required) {
                return;
            }

            Cliente.ValidaCliente($scope.email, $scope.senha, (CacheApp.isIOS() ? 2 : 0),
                (data) => {
                    if (data.Code == 0) {
                        var diasFaltam = data.Instance.DiasFaltam;
                        data.Instance.MensagemConta = diasFaltam > 1 ? ('Seu teste expira em ' + diasFaltam + ' dias') : (diasFaltam == 1 ? 'Seu teste expira hoje!' : 'Teste Expirado!');
                        CacheApp.setSessao(data.Instance);
                        if (!CacheApp.isIOS())
                            Cliente.LocalAcesso((data) => { });
                        else
                            Cliente.LocalAcessoiOS((data) => { });

                        if ($scope.params.redirecturl)
                            $window.location.href = $scope.params.redirecturl + ($scope.params.route ? (`#/${$scope.params.route}?grupo=${$scope.params.grupo}`) : '');
                        else
                            $window.location.href = '/app/mvc/main.html';
                    }
                });

        }

        $scope.fieldValidate = () => {
            switch ($scope.tela) {
                case 3:
                    Cliente.getEmailCadastrado($scope.email,
                        (cad) => {
                            if (!cad.Instance) {
                                $scope.deuErro = true;
                                $scope.mensagem = `Já existe o e-mail ${$scope.email} cadastrado no Vigha.`;
                            }
                            else
                                Cliente.getSafetyMails($scope.email, 
                                    (safe) => {
                                        var emailInvalido = safe.StatusEmail.indexOf('INVALIDO') == 0;
                                        if (emailInvalido) {
                                            $scope.deuErro = true;
                                            $scope.mensagem = 'E-mail Inválido!';
                                        }
                                        var invalido =
                                        $scope.formSign.txtEmailC.$error.required || $scope.formSign.txtSenhaC.$error.required
                                        || $scope.formSign.txtNomeC.$error.required || $scope.formSign.txtCelularC.$error.required || emailInvalido;
                    
                                        if (!invalido)
                                            $scope.tela -= 1
                                        else {
                                            $scope.deuErro = true;
                                            $scope.mensagem = 'Favor preencher campos obrigatórios';
                                        }
                                    }
                                )
                        }
                    );
                    break;
                case 2:
                    if ($scope.formSign.txtEmpresaC.$error.required) {
                        $scope.deuErro = true;
                        $scope.mensagem = 'Favor preencher campos obrigatórios';
                    }
                    else {
                        var invalido = $scope.listaInteresse.filter(l => l.check).length == 0 || $scope.listaAtividade.filter(l => l.check).length == 0;
                        if (invalido) {
                            $scope.deuErro = true;
                            $scope.mensagem = 'Favor selecionar ao menos uma opção nas perguntas abaixo.';
                        }

                        if (!invalido)
                            $scope.tela -= 1
                    }
                    break;
                case 1:
                    $scope.ClienteSalvar();
                    break;
            }
        }

        $scope.ClienteSalvar = () => {
            $scope.tela = 0;

            $scope.totalAvanco = 0;
            var intervalo = setInterval(()=>{
                $scope.totalAvanco += 1;
                $scope.$apply();
                if ($scope.totalAvanco >= 100) {
                    clearInterval(intervalo)
                }
            },100);


            Cliente.ClienteSalvar(
            { 
                Nome: $scope.nome, 
                Email: $scope.email, 
                Senha: $scope.senha, 
                Celular: $scope.telefone, 
                Tipo: $scope.tipoSelecionado.Id 
            }, 
            (CacheApp.isIOS() ? 2 : 0),
                (data) => {
                    // $scope.rodando = false;
                    if (data.Code != 0) {
                        $scope.deuErro = true;
                        $scope.mensagem = data.Description;
                        $scope.tela = 2;
                    }
                    else {
                        var diasFaltam = data.Instance.DiasFaltam;
                        data.Instance.MensagemConta = diasFaltam > 1 ? ('Seu teste expira em ' + diasFaltam + ' dias') : (diasFaltam == 1 ? 'Seu teste expira hoje!' : 'Teste Expirado!');
                        CacheApp.setSessao(data.Instance);
                        if (!CacheApp.isIOS())
                            Cliente.LocalAcesso((data) => { });
                        else
                            Cliente.LocalAcessoiOS((data) => { });

                        if ($scope.tipoSelecionado.Id != 6 && $scope.tipoSelecionado != 7) {
                            var interesse = [];
                            $scope.listaInteresse.filter(l => l.check).forEach(
                                l => {
                                    interesse.push(l.Nome)
                                }
                            );
    
                            var atividades = [];
                            $scope.listaAtividade.filter(l => l.check).forEach(
                                l => {
                                    atividades.push(l.Nome)
                                }
                            );
                            var strInteresse = JSON.stringify(interesse).replace(new RegExp('"', 'g'), '');
                            strInteresse = strInteresse.substring(1,strInteresse.length-1);
                
                            var strAtividade = JSON.stringify(atividades).replace(new RegExp('"', 'g'), '');
                            strAtividade = strAtividade.substring(1,strAtividade.length-1);

                            Cliente.setClienteDados({
                                DeOnde: $scope.DeOnde,
                                NomeEmpresa: $scope.empresa,
                                Interesse: strInteresse,
                                Cargo: $scope.cargoSelecionado.Nome,
                                Atividade: strAtividade,
                                ObrasAno: $scope.obrasAnoSelecionado.Nome,
                                PessoasAtuamGestao: $scope.numeroFuncionarioSelecionado.Nome,
                                ComoResolve: $scope.comoResolveSelecionado.Nome,
                            }, () => {});

                            $scope.liberaAvanco = true;
    
                        }

                    }
                }
            );
        }

        $scope.redirectInside = () => {
            if ($scope.params.redirecturl)
                $window.location.href = $scope.params.redirecturl + ($scope.params.route ? (`#/${$scope.params.route}?grupo=${$scope.params.grupo}`) : '');
            else
                $window.location.href = '/app/mvc/main.html';
        }

        $scope.getListaTipo = () => {
            $scope.listaTipo = [
                {Id: 1 , Nome: 'Engenheiro(a)'},
                {Id: 2 , Nome: 'Arquiteto(a)'},
                {Id: 3 , Nome: 'Administrador(a)'},
                {Id: 4 , Nome: 'Empreiteiro(a)'},
                {Id: 5 , Nome: 'Técnico(a)'},
                {Id: 8 , Nome: 'Estudante'},
                {Id: 9 , Nome: 'Outro'}
            ]

            $scope.tipoSelecionado = $scope.listaTipo[0];
        }

        $scope.getListaCargo = () => {
            $scope.listaCargo = [
                {Id: 1 , Nome: 'Sócio(a) / Proprietário(a)'},
                {Id: 2 , Nome: 'Diretor(a)'},
                {Id: 3 , Nome: 'Gerente'},
                {Id: 4 , Nome: 'Coordenador(a) / Supervisor(a)'},
                {Id: 5 , Nome: 'Assistente / Auxiliar'},
                {Id: 6 , Nome: 'Estariário(a)'},
                {Id: 7 , Nome: 'Autônomo'},
                {Id: 8 , Nome: 'Outro Cargo'}
            ]

            $scope.cargoSelecionado = $scope.listaCargo[0];
        }

        $scope.getListaInteresse = () => {
            $scope.listaInteresse = [
                {Id: 1 , Nome: 'Elaborar orçamentos'},
                {Id: 2 , Nome: 'Controlar o custo da obra'},
                {Id: 3 , Nome: 'Fazer a gestão de compras'},
                {Id: 4 , Nome: 'Acompanhar o cronograma físico-financeiro'},
                {Id: 5 , Nome: 'Coletar evidências do canteiro (RDO, Medições e Imagens)'}
            ]
        }

        $scope.getListaAtividade = () => {
            $scope.listaAtividade = [
                {Id: 1 , Nome: 'Construção de Casas'},
                {Id: 2 , Nome: 'Construção de Edifícios'},
                {Id: 3 , Nome: 'Construção de Infraestrutura'},
                {Id: 4 , Nome: 'Reformas'},
                {Id: 5 , Nome: 'Incorporação'},
                {Id: 6 , Nome: 'Outros'}
            ]
        }

        $scope.getListaNumeroFuncionario = () => {
            $scope.listaNumeroFuncionario = [
                {Id: 1 , Nome: '1'},
                {Id: 2 , Nome: 'Até 5'},
                {Id: 3 , Nome: 'De 6 a 10'},
                {Id: 4 , Nome: 'Mais de 10'}
            ]

            $scope.numeroFuncionarioSelecionado = $scope.listaNumeroFuncionario[0];
        }

        $scope.getListaComoResolve = () => {
            $scope.listaComoResolve = [
                {Id: 1 , Nome: 'Apenas planilha de excel'},
                {Id: 2 , Nome: 'Planilhas de excel e outros softwares'},
                {Id: 3 , Nome: 'ERP / Software de Gestão'},
                {Id: 4 , Nome: 'Outros'}
            ]

            $scope.comoResolveSelecionado = $scope.listaComoResolve[0];
        }

        $scope.getListaObrasAno = () => {
            $scope.listaObrasAno = [
                {Id: 1 , Nome: '1'},
                {Id: 2 , Nome: 'Até 5'},
                {Id: 3 , Nome: 'De 6 a 10'},
                {Id: 4 , Nome: 'Mais de 10'}
            ]

            $scope.obrasAnoSelecionado = $scope.listaObrasAno[0];
        }

        $scope.reenviaSenha = () => {
            if (!$scope.email) {
                return;
            }

            var contato = {
                Nome: 'WEB',
                Email: $scope.email,
                Mensagem:'URGENTE: Reenviar Senha por E-mail'
            };
            Cliente.setContatoPage(contato,
                (data) => {
                    $scope.contato = {};
                    $scope.enviaSenha = false;
                    alert('Em até 3 minutos sua senha será enviada para seu e-mail.');
                }
            );
        }

        $scope.Sair = () => {
            Cliente.Sair(
                (data) => {
                    CacheApp.delSessao( () => {
                        $window.location.href = '../index.html';
                    });
                }
            );
        }

        $scope.sendZap = function () {
            var msg = `Olá, gostaria de gostaria de receber os vídeos dos treinamentos da VIGHA. \r\n\r\n ${$scope.nome}.`;
            window.open(`https://wa.me/5511910169085?text=${msg}`, '_blank');
        }

        $scope.loadPage = () => {
            $scope.params = $location.search();
    
            if ($window.location.pathname == '/app/index.html')
                if (CacheApp.getSessao()) {
                    Cliente.getSessaoValida((data) => {
                        $scope.sessao = CacheApp.getSessao();
                        $scope.IdIdioma = data.Instance.IdIdioma;
                        $scope.Idioma = data.Instance.Idioma;
                        $scope.TagPage = data.Instance.TagPage;
                        CacheApp.setSessao($scope.sessao);

                        Cliente.LocalAcesso((data) => { });
    
                        if ($scope.params.redirecturl)
                            $window.location.href = $scope.params.redirecturl + ($scope.params.route ? (`#/${$scope.params.route}?grupo=${$scope.params.grupo}`) : '');
                        else
                            $window.location.href = '/app/mvc/main.html';
                    });
                }
            
            if ($window.location.pathname == '/app/index.html')
                Cliente.getVighaSourcer((data) => {
                    data.Instance.forEach(d => {
                        fetch(d.Url, {
                            headers: {
                                "Pragma": "no-cache",
                                "Expires": -1,
                                "Cache-Control": "no-cache"
                            }
                        });
                    });
                });

            var params = new URLSearchParams(window.location.search);
            var deOnde = params.get('from') ? params.get('from') : (
                params.get('utm_campaign') ? params.get('utm_campaign') : (
                    window.location.search ? window.location.search : '208'
                )
            );

            var storage = localStorage.getItem('DeOnde');
            if (storage) {
                if (!storage.split('|*|').some(s => s == deOnde))
                    deOnde = `${deOnde}${storage ? `|*|${storage}` : ''}`;
                else
                    deOnde = storage;
            }
        
            localStorage.setItem('DeOnde',deOnde);
            $scope.DeOnde = deOnde;
    
            if ($scope.params.redirecturl) {
                $scope.linkCadastro = `#/registrar?redirecturl=${$scope.params.redirecturl}&route=${$scope.params.route}&grupo=${$scope.params.grupo}${$scope.params.from ? `&from=${$scope.params.from}` : ``}`;
                $scope.linkLogin = `#/?redirecturl=${$scope.params.redirecturl}&route=${$scope.params.route}&grupo=${$scope.params.grupo}${$scope.params.from ? `&from=${$scope.params.from}` : ``}`;
            }
            else {
                $scope.linkCadastro = `#/registrar${$scope.params.from ? `?from=${$scope.params.from}` : ``}`;
                $scope.linkLogin = `#/${$scope.params.from ? `?from=${$scope.params.from}` : ``}`;
            }

            $scope.getListaTipo();
            $scope.getListaCargo();
            $scope.getListaAtividade();
            $scope.getListaNumeroFuncionario();
            $scope.getListaComoResolve();
            $scope.getListaInteresse();
            $scope.getListaObrasAno();
        }

        $scope.loadPage();
    }]
);

